给定一个包含 [0, n] 中 n 个数的数组 nums ,找出 [0, n] 这个范围内没有出现在数组中的那个数。
示例 1:
输入:nums = [3,0,1]
输出:2
解释:n = 3,因为有 3 个数字,所以所有的数字都在范围 [0,3] 内。2 是丢失的数字,因为它没有出现在 nums 中。
示例 2:
输入:nums = [0,1]
输出:2
解释:n = 2,因为有 2 个数字,所以所有的数字都在范围 [0,2] 内。2 是丢失的数字,因为它没有出现在 nums 中。
示例 3:
输入:nums = [9,6,4,2,3,5,7,0,1]
输出:8
解释:n = 9,因为有 9 个数字,所以所有的数字都在范围 [0,9] 内。8 是丢失的数字,因为它没有出现在 nums 中。
示例 4:
输入:nums = [0]
输出:1
解释:n = 1,因为有 1 个数字,所以所有的数字都在范围 [0,1] 内。1 是丢失的数字,因为它没有出现在 nums 中。
提示:
n == nums.length
1 <= n <= 104
0 <= nums[i] <= n
nums 中的所有数字都 独一无二
进阶:你能否实现线性时间复杂度、仅使用额外常数空间的算法解决此问题?
来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/missing-number
class Solution {public int missingNumber(int[] nums) {HashSet set=new HashSet();for(int i=0;iset.add(nums[i]);}int j=0;for(j=0;j<=nums.length;j++){if(!(set.contains(j))){break;}}return j;}
}
class Solution {public int missingNumber(int[] nums) {int xor = 0;int n = nums.length;for (int i = 0; i < n; i++) {xor ^= nums[i];}for (int i = 0; i <= n; i++) {xor ^= i;}return xor;}
}
根据出现的次数的奇偶性,可以使用按位异或运算得到丢失的数字。按位异或运算e满足交换律和结合律,且对任意整数α都满足a⊕a =0和a ⊕0 =a。
将数组 nums 的元素之和记为 arrSum
则 arrSum 比 total 少了丢失的一个数字,因此丢失的数字即为total 与 arrSum之差。
链接:https://leetcode.cn/problems/missing-number/solution/diu-shi-de-shu-zi-by-leetcode-solution-naow/
上一篇:刷题(第二周)